package com.jojubanking.boot.module.system.service.dztype;

import java.util.*;
import javax.validation.*;
import com.jojubanking.boot.module.system.controller.admin.dztype.vo.*;
import com.jojubanking.boot.module.system.dal.dataobject.dztype.DzTypeDO;
import com.jojubanking.boot.framework.common.pojo.PageResult;

/**
 * 导诊类型 Service 接口
 *
 * @author admin
 */
public interface DzTypeService {

    /**
     * 创建导诊类型
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Integer createDzType(@Valid DzTypeCreateReqVO createReqVO);

    /**
     * 更新导诊类型
     *
     * @param updateReqVO 更新信息
     */
    void updateDzType(@Valid DzTypeUpdateReqVO updateReqVO);

    /**
     * 删除导诊类型
     *
     * @param id 编号
     */
    void deleteDzType(Integer id);

    /**
     * 获得导诊类型
     *
     * @param id 编号
     * @return 导诊类型
     */
    DzTypeDO getDzType(Integer id);

    /**
     * 获得导诊类型列表
     *
     * @param ids 编号
     * @return 导诊类型列表
     */
    List<DzTypeDO> getDzTypeList(Collection<Integer> ids);

    /**
     * 获得导诊类型分页
     *
     * @param pageReqVO 分页查询
     * @return 导诊类型分页
     */
    PageResult<DzTypeDO> getDzTypePage(DzTypePageReqVO pageReqVO);
    PageResult<DzTypeDO> getDzTypePageGroup(DzTypePageReqVO pageReqVO);
    PageResult<DzTypeDO> getDzTypeGroup(DzTypePageReqVO pageReqVO);

    /**
     * 获得导诊类型列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 导诊类型列表
     */
    List<DzTypeDO> getDzTypeList(DzTypeExportReqVO exportReqVO);

}
